package com.sf.day09.lx2;

/**
 * 银行信用卡
 */
public class CreditCard extends DepositCard{
    private double maxOverdraft;//当月最多可以透支额度
    private double overdraft;//本月已透支额度

    public double getMaxOverdraft() {
        return maxOverdraft;
    }

    public void setMaxOverdraft(double maxOverdraft) {
        this.maxOverdraft = maxOverdraft;
    }

    public double getOverdraft() {
        return overdraft;
    }

    public void setOverdraft(double overdraft) {
        this.overdraft = overdraft;
    }

    @Override
    public void withdraw(double money) {
        //超过可透支额度
        if(money > getBalance() + maxOverdraft - overdraft){
            System.out.println("超过可透支额度");
            return;
        }
        if(money <= getBalance()){ //不用透支
            super.withdraw(money);
            return;
        }
        overdraft += money - getBalance();  //需要透支
        setBalance(0);
    }
    @Override
    public void save(double money) {
        if(money < 0){
            System.out.println("存款金额不能为负数");
            return;
        }
        if(money <= overdraft){//偿还部分透支金额
            overdraft -= money;
            return;
        }
        //偿还所有透支金额，还有剩余
        setBalance(getBalance() + (money - overdraft));
        overdraft = 0;
    }

    @Override
    public String getInfo() {
        return super.getInfo() +"，本月可透支总额度：" + maxOverdraft + "，本月已透支：" + overdraft +"，本月还可透支：" + (maxOverdraft - overdraft);
    }
}
