package com.sf.day19._01_exception;

import com.sf.day19._01_exception.able.ILoginAble;
import com.sf.day19._01_exception.able.impl.LoginAbleImpl;
import com.sf.day19._01_exception.ex.LoginException;
import com.sf.day19._01_exception.util.Result;
import com.sf.day19._01_exception.vo.LoginVO;

import java.util.Scanner;

public class Test1 {
    public static void main(String[] args) throws IllegalAccessException {
        /**
         * 练习  : 定义一个方法 , 方法的参数接收一个数组 , 在方法中遍历数组，对比两种方式：
         *
         * - 如果方法接收的数组为null  , 使用打印输出语句提示
         * - 如果方法接收的数组为null  , 使用抛出异常对象解决
         */
//        int [] arr = null;
//        method1(arr);
//        try{
//            method2(arr);
//        }catch (NullPointerException e){
//            System.out.println("对于空指针进行处理");
//        }

        // 用户输入账号和密码以及验证码
        // 补充: 创建一个LoginVO对象(username,password,code) , 静态代码中初始化一个{"admin","123"."abce"}
        // 要求1 面相接口编程  login(LoginVo vo);
        // 要求2 如果username 或者是password 为空抛出NullPointException
        // 要求3 如果验证码为空 抛出一个空指针异常
        // 要求4 那用户输入验证码和loginvo 的验证码abce 比较如果不正确throw IllegalArgumentException
        // 要求4 那用户输入username 和"admin" 密码
        // 和初始化当中admin 密码也是和初始化对象密码比较账号密码正确在控制台当中输入登录成功,否则登录失败
        // 要求5 同时要在login 方法上提醒调用者方法可能出现的异常

        // 扩展: 在loginVO 定义一个验证码使用UUID 生成一个6位数的验证码然后存放LoginVO
        method3();
    }

    private static void method3() throws IllegalAccessException {
        // 在控制台当中输入 账号密码和验证码
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入账号: ");
        String username = scanner.next();
        System.out.println("请输入密码: ");
        String password = scanner.next();
        System.out.println("请输入验证码: ");
        String code = scanner.next();
        ILoginAble loginAble = new LoginAbleImpl();

        // 需求: 要在上午案例基础修改
        //      要求1 方法内部要抛出自定义异常
        //      要求2 如果输入信息为空 {code:500,msg:"参数不能为空"}
        //      要求3 如果输入验证码错误{code:500,msg: "验证码错误"}
        //      要求4 如果输入账号密码错误{code:500,msg: "账号密码错误"}
        //      要求4 如果输入账号密码正确{code:200,msg;"操作成功"}
        try{
            loginAble.login(new LoginVO(username,password,code));
            System.out.println(new Result(200,"操作成功"));
        }catch (LoginException e){
            e.printStackTrace();
            System.out.println(new Result(500,e.getMessage()));
        }
    }

    private static void method1(int[] arr) {
        // throw new 异常类型 ,  throw new NullPointException();
        // 第一种情况如果出现为空情况
        if(arr == null){
            System.out.println("数组为空");
            return;
        }

        for (int i = 0; i < arr.length; i++) {
            System.out.println(arr[i]);
        }
    }

    private static void method2(int[] arr) {
        // throw new 异常类型 ,  throw new NullPointException();
        // 第一种情况如果出现为空情况
        // 1 知道出现了错误 , 错误信息更加详细
        // 2 在调用者哪也可以提前使用trycatch处理异常信息
        if(arr == null){
            throw new NullPointerException();
        }

        for (int i = 0; i < arr.length; i++) {
            System.out.println(arr[i]);
        }
    }
}
