package com.sf.day20._02_io;

import com.sf.day20._02_io.dt.Student;
import com.sf.day20._02_io.dt.User;

import java.io.*;
import java.lang.reflect.Field;
import java.util.*;

public class Test {
    public static void main(String[] args) throws IOException {
//        method1();
//        method2();
//        method3();

//        method4();
//        method5();

//        method6();
//        method8();
        method9();
    }

    private static void method9() throws IOException {
        /**
         * 现在在d盘有一个文件 , 文件内容为 abcdedfaedfg
         * 要求读取文件内容统计每个字符出现次数
         * 最终把内容输出到d 盘下面c.txt 当中
         * a - 2次
         * b - 3次
         * .....
         */
        //1 创建两个File 分别只想a.txt 和b.txt
        File file = new File("D:\\a.txt");
        File file1 = new File("D:\\c.txt");
        //2 创建字符输入流和字符输出流
        FileReader fileReader = new FileReader(file);
        FileWriter fileWriter = new FileWriter(file1);
        //3 创建字符数组char[] buffer
        //[a,c,e,d,c ,0,0,0,0,0,0]
        char[] buffer = new char[1024];
        //4 fileReader.read(buffer)
        fileReader.read(buffer);
        //5 创建Map<Char,Integer> map
        Map<Character,Integer> map = new HashMap<>();
        //6 遍历字符数组
        for (char c : buffer) {
            if(c == 0){
                continue;
            }
            //7 判断在map 当中是否存在,如果不存在就设置数量为1
            if(!map.containsKey(c)){
                map.put(c,1);
            }else{
                //8 如果存在就上之前数量+1
                map.put(c,map.get(c) + 1);
            }
        }
        System.out.println(map);

        //9 遍历map ,拿到每一个key-value

        for (Map.Entry<Character, Integer> entry : map.entrySet()) {
            //10 把文件当中去输出内容
            Character key = entry.getKey();    // a b c d
            Integer value = entry.getValue();  // 次数
            // a - 2   b -1  c -1
            // 调用输出流进行输出
            fileWriter.write(key + " - " + value);
            fileWriter.write(System.lineSeparator());
        }
        // 关闭资源
        fileReader.close();
        fileWriter.close();

    }

    private static void method8() throws IOException {
        File file = new File("D:\\a.txt");
        // 创建管道
        FileReader fileReader = new FileReader(file);

        char[] buffer = new char[2];
        int len = 0;
        while ((len = fileReader.read(buffer))!=-1){
            System.out.println(Arrays.toString(buffer));
        }
        // 关闭资源
        fileReader.close();
    }

    private static void method7() throws IOException {
        //1  确定目的地
        File file = new File("D:\\a.txt");
        //2 创建管道
        FileWriter fileWriter = new FileWriter(file);
        //3 把数据写出去
        fileWriter.write("你好中国啊 aaaaaaaa");
        //4 关闭资源
        fileWriter.close();
    }



    /**
     * 需求2 : 现在d 盘中有一个b.txt 的文件内容为 i love coding
     *         要求吧b.txt 内容拷贝到 c.txt中内容 你的名字 + i love coding
     */
    private static void method6() throws IOException {
        // 创建File  b.txt
        File file = new File("D:\\B.txt");
        // 创建File  c.txt
        File file1 = new File("D:\\C.txt");
        // 创建输入流FileInputStream ->file
        FileInputStream fileInputStream = new FileInputStream(file);
        // 创建输出流FileOutputStream-> file
        FileOutputStream fileOutputStream = new FileOutputStream(file1);
        // 定义byte数组
        byte[] buffer= new byte[1024];
        // len = 0
        int len = 0;
        // while 读数据
        while ((len = fileInputStream.read(buffer))!=-1){
            // 在循环内部写数据
            String str = new String(buffer,0,len,"UTF-8");
            // 往c.txt 写
            fileOutputStream.write(("fanjialong "+str).getBytes());
        }

        // 关闭资源
        fileInputStream.close();
        fileOutputStream.close();
    }

    /**
     *  现在在d盘的a.txt 文件中有一个内容name=zhangsan
     *  要把内容存到map 当中key = name  value 值等于zhangsan
     */
    private static void method5() throws IOException {
        File file = new File("D:\\a.txt");
        // 创建一个输入流
        FileInputStream fileInputStream = new FileInputStream(file);
        // 读取数据
        byte[] buffer = new byte[1024];
        int len = 0;

        len = fileInputStream.read(buffer);
        // name=zhangsan
        String str = new String(buffer,0,len,"UTF-8");
        // 把数据存储到map 当中key name value zhangsan
        String[] arr = str.split("=");
        Map<String,Object> map=  new HashMap<>();
        map.put(arr[0],arr[1]);
        System.out.println(map);
        // 关闭资源
        fileInputStream.close();
    }

    /**
     * 学习输入流： 如何使用输入流读取磁盘的数据
     */
    private static void method4() throws IOException {
        /**
         * - 1 确定源和目的地
         * - 2 创建管道（创建文件字节输入流对象）
         * - 3 把数据读进来
         * - 4 释放资源
         */
         //1 创建File
        File file = new File("D:\\a.txt");
        // 2 创建输入管道，FileInputStream
        FileInputStream fileInputStream = new FileInputStream(file);
        // 3 调用file.read（）方法读取, 一个字节一个字节的读取
        //abc中
        // file.read() 方法一个字节一个字节读取太麻烦了
        //abc中a   1022 97 1023 98  1024  -27   中
        byte[] b = new byte[1024];
        int len = 0;
        //[97 98 99]   abc
        //[ -27 -127 -189]  中
        //[97 -127 -189]  a 乱码
        // while循环什么时候结束，文件读取完结束
        // 什么时候文件读取完 ， read（） 返回值是-1
        // 如果read() 方法不传递byte数组默认就是读取一个字节
        // 如果read()  方法传递byte 数组那读取的就是有效长度
        while ((len=fileInputStream.read(b)) !=-1){
            // 不等于-1 表示文件还有内容
            // String(字节数组，从字节数组那一个位置开始0，有效长度，编码)
            // 因为我们发现最后一次读取我们要看有效长度
            String str = new String(b,0,len,"UTF-8");
            System.out.println(str);
        }
        // 4 关闭资源
        fileInputStream.close();
    }






    //需求：用户可以在控制台当中输入 id  ,name  ,age ,score
    // 要求最终把内容输出到文件c.txt当中
    /**
     *    id    name     age  score     第一部分
     *    1     zhangsan 18    70
     *    2     lisi     19    60
     *    3     wangwu   17    50       第二部分
     *    总人数：3人      第三部分
     *    总分数：180      第四部分
     *    平均分：60       第五部分
     *
     */

    private static void method3() throws IOException {
        // 1 创建Scaner 对象
        Scanner scanner = new Scanner(System.in);
        // 2 获取id name age score
        List<Student> students = new ArrayList<>();
        for (int i = 0; i < 3; i++) {
            // 3 吧信息封装到一个对象当中User
            System.out.println("请输入id");
            long id = scanner.nextLong();
            System.out.println("请输入name:");
            String name = scanner.next();
            System.out.println("请输入age");
            int age = scanner.nextInt();
            System.out.println("请输入分数");
            int score = scanner.nextInt();
            Student student = new Student(id,name,age,score);
            // 4 User 对象放到一个集合当中 List<User> list  User1 User2 User3
            students.add(student);
        }
        // 5 创建File file 指定磁盘文件
        File file = new File("D:\\a.txt");
        // 6 FileOutputStream outputStream
        FileOutputStream fileOutputStream = new FileOutputStream(file,true);
        // 7 outPutStream.wirte("id  name  age  score".getBytes("UTF-8"));
        fileOutputStream.write("id  name  age  score".getBytes("UTF-8"));
        // 8 write(换行)
        fileOutputStream.write(System.lineSeparator().getBytes("UTF-8"));
        Integer countScore = 0;
        // 9 便利集合，拿到集合每一个元素
        for (Student student : students) {
//            1     zhangsan 18    70
            String str = student.getId() + "  " + student.getName() +"  " + student.getAge()+"  " + student.getScore();
            fileOutputStream.write(str.getBytes("UTF-8"));
            // 10 write(user.getId +" " + user.getName() +" " + user.getAge(" ")+ user.getScore().getBytes("UTF-8"))
            fileOutputStream.write(System.lineSeparator().getBytes("UTF-8"));
            // 计算总分数
            countScore +=student.getScore();
        }
        // 11 计算出来总人数list.size ， 然后调用outuptSteram 去写出
        fileOutputStream.write(("总人数："+students.size()).getBytes("UTF-8"));
        fileOutputStream.write(System.lineSeparator().getBytes("UTF-8"));
        // 12 计算出来总分数， 然后调用outPutsteam 去写出
        fileOutputStream.write(("总分数:"+countScore).getBytes());
        fileOutputStream.write(System.lineSeparator().getBytes("UTF-8"));
        // 13 计算平均分， 然后写出   countPrice/students.size();
        fileOutputStream.write(("平均数"+ countScore/students.size()).getBytes("UTF-8"));

    }
    //需求：现在又一个List<User(id name integal)> 集合
    /**
     * 集合当中有3 个元素 User(1L,zhangsan,10) User2 (2L, lisi ,10) User3(3L,wangwu ,20)
     * 要求把名字输出到一个文件 b.txt     zhangsan-lisi-wangwu
     * 把积分综合添加到一个c.txt 文件中   40
     */
    private static void method2() throws IOException {
        List<User> list = new ArrayList<>();
        list.add(new User(1L,"zhangsan",10));
        list.add(new User(2L,"lisi",10));
        list.add(new User(3L,"wangwu",20));

        File file = new File("D:\\b.txt");
        File file1 = new File("D:\\c.txt");
        // 拼接字符串
        StringBuilder stringBuilder = new StringBuilder();
        // 便利jihe
        Integer sum = 0;
        for (int i = 0; i < list.size(); i++) {
            User user = list.get(i);
            if(i == list.size()-1){
                stringBuilder.append(user.getName());
            }else{
                stringBuilder.append(user.getName()).append("-");
            }
            sum += user.getIntegral();
        }
        // 往文件当中输出内容
        FileOutputStream fileOutputStream = new FileOutputStream(file);
        FileOutputStream fileOutputStream1 = new FileOutputStream(file1);
        // 往b.txt 输出 zhangsan-lisi-wangwu
        fileOutputStream.write(stringBuilder.toString().getBytes("UTF-8"));
        // 往c.txt 输出40
        fileOutputStream1.write(sum.toString().getBytes("UTF-8"));

        // 关闭资源
        fileOutputStream.close();
        fileOutputStream1.close();



    }

    private static void method1() throws IOException {
        /**
         * - 1 确定源和目的地
         *
         * - 2 创建管道（创建字节输出流对象）
         *
         * - 3 把数据写出去
         *
         * - 4 释放资源
         */
        //1 创建目的地 其实就是创建File
        File file = new File("D:\\abc\\f.txt");
        //2 创建管道 ， 其实就是创建输出流
        // 在实际开发当中我们在写入内容时候不想覆盖而是在之前的内容的基础上进行增加
        // fileOutputSteram（appned: 是否追加）
        FileOutputStream fileOutputStream = new FileOutputStream(file,true);
        //3 往文件当中去写内容
//        fileOutputStream.write(105);
//        fileOutputStream.write(108);

        fileOutputStream.write(System.lineSeparator().getBytes());
        String str = "中国";
        fileOutputStream.write(str.getBytes("UTF-8"));
        //4 关系资源
        fileOutputStream.close();
     }



}
