package com.sf.day21._01_buffer_io;

import java.io.*;

public class Test {
    public static void main(String[] args) throws IOException {
//        method2();
//        method3();
//        method4();
        method5();
    }


    /**
     * 需求2 :
     * 现在有一个文件的内容为
     * 我是清风拂过岭，
     * 爱河潺潺润桃花。
     * 中国大地春常在，
     * 国泰民安享岁华。
     *
     * 最终把这首诗每一行的第一字 拼接我爱中国  把他输出到一个文件中
     *
     */
    private static void method5() throws IOException {
        // 缓冲字符输入流
        BufferedReader bufferedReader = new BufferedReader(new FileReader(new File("d:\\a.txt")));
        // 缓冲字符输出流
        BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(new File("d:\\d.txt")));

        String str = null;
        StringBuilder sb = new StringBuilder();
        while ((str = bufferedReader.readLine())!=null){
            char[] chars = str.toCharArray();
            sb.append(chars[0]);
        }
        bufferedWriter.write(sb.toString());
        //关闭资源方法
        bufferedReader.close();
        bufferedWriter.close();

    }

    /**
     * 现在在d盘中有一个a.txt 日志文件
     * 要求把error 错误信息输出到另外一个文件当中
     */
    private static void method4() throws IOException {
        // 缓冲字符输入流
        BufferedReader bufferedReader = new BufferedReader(new FileReader(new File("d:\\a.txt")));
        // 缓冲字符输出流
        BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(new File("d:\\error.txt")));

        String str = null;
        while ((str = bufferedReader.readLine())!=null){
            //判断内容是否包含error
            if(str.contains("error")){
                //吧这行内容写到文件中
                bufferedWriter.write(str);
                bufferedWriter.newLine();
            }
        }
        // 关闭资源
        bufferedReader.close();
        bufferedWriter.close();

    }




    private static void method3() throws IOException {
        // 字符缓冲流   字符缓冲输入流 和字符缓冲输出Luis
        // 使用字符输入缓冲流
//        File file = new File("d:\\a.txt");
//        FileReader fileReader = new FileReader(file);
        BufferedReader bufferedReader = new BufferedReader(new FileReader(new File("d:\\a.txt")));
        // 把a.txt 内容写到 b.txt 当中
        BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(new File("d:\\b.txt")));

        String st = null;
        while ((st=bufferedReader.readLine())!=null){
            bufferedWriter.write(st);
            bufferedWriter.newLine();
        }
        bufferedReader.close();
        bufferedWriter.close();
    }

    private static void method2() throws IOException {
        // 把d盘下的视频 拷贝到d盘的a.avi当中
        // 要求使用字节流进行操作,一次性读取一个 ,要求统计一共耗时多久
        // 在开始的时候记录一下时间, 在结束的时候记录一下时间观察一共耗时多久
        long start = System.currentTimeMillis();
        //TODO: io操作
        // 1 创键File d盘视频   File 指向a.avi
        File file = new File("D:\\a.mp4");
        File file1 = new File("D:\\b.mp4");
        // 2 创建字节输入流和字节输出流
        FileInputStream fileInputStream = new FileInputStream(file);

        // 创建字节输入缓冲流
        BufferedInputStream bufferedInputStream = new BufferedInputStream(fileInputStream);
        FileOutputStream fileOutputStream = new FileOutputStream(file1);
        BufferedOutputStream bufferedOutputStream = new BufferedOutputStream(fileOutputStream);
        // 3 定义byte数组[1]
        byte[] buffer = new byte[1];
        int len = 0;
        // 4 while 读取
        while ((bufferedInputStream.read(buffer))!=-1){
            // 5 在就往另外一文件当中写内容
            bufferedOutputStream.write(buffer);
        }
        // 6 关闭资源
        long end = System.currentTimeMillis();
        System.out.println("耗时时间:" +(end-start)/1000 + " 秒");
        // 使用缓存流 必须要调用close 方法,只要调用close 方法他才能把缓存区内容 写或者读 到文件中
        bufferedInputStream.close();
        bufferedOutputStream.close();
    }

    public static void method1() throws IOException {
        // 把d盘下的视频 拷贝到d盘的a.avi当中
        // 要求使用字节流进行操作,一次性读取一个 ,要求统计一共耗时多久
        // 在开始的时候记录一下时间, 在结束的时候记录一下时间观察一共耗时多久
        long start = System.currentTimeMillis();
        //TODO: io操作
        // 1 创键File d盘视频   File 指向a.avi
        File file = new File("D:\\a.mp4");
        File file1 = new File("D:\\b.mp4");
        // 2 创建字节输入流和字节输出流
        FileInputStream fileInputStream = new FileInputStream(file);
        FileOutputStream fileOutputStream = new FileOutputStream(file1);
        // 3 定义byte数组[1]
        byte[] buffer = new byte[1];
        int len = 0;
        // 4 while 读取
        while ((fileInputStream.read(buffer))!=-1){
            // 5 在就往另外一文件当中写内容
            fileOutputStream.write(buffer);
        }
        // 6 关闭资源
        long end = System.currentTimeMillis();
        System.out.println("耗时时间:" +(end-start)/1000 + " 秒");
    }


}
