package com.sf.day22._02_xml;

import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.junit.Test;

import java.io.InputStream;
import java.util.List;

public class XMLTest {
    /**
     * 我今天主要是学习xml 格式语法
     * 今天我们会xml 文件当中写一些<标签>， 今天写的标签他是没有什么限制的你可以随意起名
     *
     *
     *
     * 但是后续我们学习了框架比如学习了spring 框架， spring 他的配置也是xml 格式
     * 他配置文件当中标签就不开业i随意的写了
     * <bean></bean>  在spring 你必须要按照他的规范去写 ， 他才能够识别
     *
     *  今天我们比较轻松我们没有学习框架， 那标签名字你可以随便写
     *  但是切记： 后续学习了框架必须要按照人家的规范去写， 他才可以识别
     *
     *  不论是properties 配置文件 还是xml 配置文件 都属于配置文件
     *  配置解决问题：  解决硬编码问题
     *
     *  最终都需要把配置文件当中内容读取到程序当中
     *  今天我们学习xml 这个文件需要我们来解析读取  (了解)
     *  后续我们学习了框架，这个信息是不需要我们来解析，框架来解析 ，后面我们的项目用的都是框架
     *
     *  在解析XML 的时候
     *  他把属性封装到Attribute 当中
     *  把标签内容封装到Text 对象当中
     *  文档是用的Document 对象
     *  元素是使用Element 元素
     *
     *
     */





    /**
     * Element getRootElement()：Document的方法，用来获取根元素；
     * List elements()：用来获取所有子元素
     * Element element(String name)：用来获取第一个指定名字的子元素；
     * String getText() 用于获取元素的文本内容
     */
    @Test
    public void test() throws DocumentException {
        // 1 使用类加载器获取xml 文件内容
        ClassLoader contextClassLoader = Thread.currentThread().getContextClassLoader();
        InputStream inputStream = contextClassLoader.getResourceAsStream("user.xml");
        // 2 创建SAXReader对象-xml read   Properties -properties   load
        SAXReader saxReader = new SAXReader();
        // 3 调用SAXReader.read(in) 方法 读取数据 Document 对象
        Document document = saxReader.read(inputStream);
        // 4 根据文档对象获取跟元素
        Element element = document.getRootElement();
        // 5 根据跟元素获取他的子元素
        List<Element> elements = element.elements();
        // 6 获取第二个节点
        Element element1 = elements.get(1);
        Attribute attribute = element1.attribute("id");
        System.out.println(attribute.getValue());
        // 7 获取name 元素
        Element nameElement = element1.element("name");
        // 8 获取name 的内容
        String text = nameElement.getText();
        System.out.println(text);
    }

    /**
     * 把上午的Properties登录的案例 修改成使用XML 方式去操作
     * 跟节点叫做db    下面有两个子节点  <username>zhangsan</username>  <password>123</password>
     */
}
