package com.sf.day23._02_lombda;

import com.sf.day23._02_lombda.dt.Data;
import com.sf.day23._02_lombda.dt.Product;
import com.sf.day23._02_lombda.service.*;
import org.junit.Test;

import java.util.*;

public class LombdaTest {
    @Test
    public void test(){
        // 创建一个线程 ,并且把这个线程启动起来, 启动以后执行run方法
        // 通过匿名内部类的方式进行传递参数
//        new Thread(new Runnable() {
//            public void run() {
//                System.out.println("开一个子线程处理一个耗时操作");
//            }
//        }).start();

        // lambda 表达式的初体验
        /**
         * lombda 表达式有一个很大作用就是简化我们匿名内部类的写法
         *
         */
        new Thread(()-> System.out.println("开启一个线程")).start();
    }
//


//    private void findProductByPrice(List<Product> products) {
//        for (Product product : products) {
//            if(product.getPrice()>1000){
//                System.out.println(product);
//            }
//        }
//    }

//    public void findProductByName(List<Product> list){
//        // 遍历list 集合 判断proudct.getName.contains("手机")
//        for (Product product : list) {
//            if(product.getName().contains("手机")){
//                System.out.println(product);
//            }
//        }
//    }
//
//    需求1: 筛选出所有名称包含手机的商品
//    需求2: 筛选出所有价格大于1000的商品
    @Test
    public void test2(){
        List<Product> products = Data.products;
//        findProduct(products);
//        findProduct(products, new IMyPredicate() {
//            @Override
//            public boolean isFlag(Product product) {
//                return product.getName().contains("手机");
//            }
//        });
        findProduct(products,p-> p.getName().contains("手机"));
    }
    @Test
    public void test3(){
        List<Product> products = Data.products;
//        findProduct(products, new IMyPredicate() {
//            @Override
//            public boolean isFlag(Product product) {
//                return product.getPrice()>1000;
//            }
//        });
        findProduct(products,p-> {
            return p.getPrice()>1000;
        });
    }
    /**
     *  想要优化一下代码:
     *  定义一个接口-方法, boolean isFlag()
     *  要求吧提供一个方法 findProduct(List<Product> products, MyPredicate predicate)
     *  在测试类当中调用这个方法去实现之前的两个需求
     */

    public void findProduct(List<Product> list, IMyPredicate predicate){
        for (Product product : list) {
            if(predicate.isFlag(product)){
                System.out.println(product);
            }
        }
    }

//   练习1：编写一个接口 IShowable，接口中存在一个抽象方法show，
//    无参数无返回值,在方法里面打印无参数无返回值
//   在定义方法这方法需要传递一个参数, 参数类型就是IShowable   public void metho1(IShowable show){}

    /**
     * lamda表示主要就是为了解决特定条件的匿名内部类的一个语法糖
     * 条件: 必须是一个接口当中只有一个方法
     *  方法类型: 无参数无返回值  无参数有返回值  有参数有返回值  有参数无发回执
     *  我们就是学习这几个类型方法, 使用lamda 表达式如何去写
     *
     *  简化语法
     *  (形参)->  {}
     *  多个形参要用,进行分割, 如果只有一个参数 () 可以省略不写,如果有多个参数必须写()
     *  {} 方法体,如果只有一行代码, 可以省略{}  如果有多行内容必须写}{}
     *
     *  练习2：编写一个接口 IPrintable，接口中存在一个抽象方法print，
     *  有参数无返回值，定义一个方法(接口) 在测试方法中调用  使用lambda表达式
     */
    @Test
    public void test4(){
//        printInfo(new IShowAble() {
//            @Override
//            public void show() {
//                System.out.println("无参数无返回值");
//            }
//        });
        // 使用lambda表达式进行简化
        printInfo(()-> {
            System.out.println("第一行代码");
            System.out.println("第二行代码");
        });
    }

    @Test
    public void test5(){
//        print("123123", new IPrintable() {
//            @Override
//            public void print(String name) {
//                System.out.println(name);
//            }
//        });
        print("!123",10,(e,a) -> System.out.println(e + "---" + a));
    }

    public void printInfo(IShowAble showAble){
        showAble.show();
    }

    public void print(String name,Integer age,IPrintable iPrintable){
        iPrintable.print(name,10);
    }



    @Test
    public void test56(){
//        random(new IRandomable() {
//            @Override
//            public String getRandom() {
//                return "随机数";
//            }
//        });

        // lambda表达式简化
        random(()-> {
//            return "随机数";
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < 5; i++) {
                Random random = new Random();
                int randomVal = random.nextInt(10);
                sb.append(randomVal);
            }
            return sb.toString();
        });


    }

    //练习3：编写一个接口 IRandomable，接口中存在一个抽象方法getRandom，
    // 无参数有返回值，传入对应的lambda表达式

    public void random(IRandomable randomable){
        String random = randomable.getRandom();
        System.out.println(random);
    }


    /**
     * 需求1
     * 一个接口有一个方法getRandom(),
     * 先在要求提供一个方法返回5个数数字验证码
     * 要求使用使用lambda 表达式
     *
     * 需求2
     * 定义一个接口-接口有一个方法,
     * String(是集合内容)  get(List<String> list , int index)
     * 调用的时候要使用lambda 表达式
     */

    @Test
    public void test6(){
        List<String> list = Arrays.asList("zhangsan", "lisi", "wangwu");
        String result = method1(list, 1, (l, i) -> l.get(i));
        System.out.println(result);
    }


    public String method1(List<String> list,int index,IFunctionAble able){
        return able.get(list,index);
    }

    @Test
    public void test7(){
        // 先在有一个List 集合我想要遍历List
        List<String> list = Arrays.asList("1123", "@34", "@#4234");
        // for 循环
//        for (int i = 0; i < list.size(); i++) {
//            System.out.println(list.get(i));
//        }
        // forEach
//        for(String str: list){
//            System.out.println(str);
//        }
        // 调用forEach 方法进行遍历
//        list.forEach(new Consumer<String>() {
//            @Override
//            public void accept(String s) {
//                System.out.println(s);
//            }
//        });
//        list.forEach(s -> System.out.println(s));

        Map<String,String> map = new HashMap<>();
        map.put("手机","小米");
        map.put("笔记本","苹果笔记本");
        map.put("鼠标","罗技鼠标");

        // map 遍历方式主要有两种方式
        // map.entrySet()  map.keySet();
//        for (Map.Entry<String, String> stringStringEntry : map.entrySet()) {
//            System.out.println(stringStringEntry);
//        }
//        Set<String> keys = map.keySet();
//        for (String key : keys) {
//            System.out.println(key +"="+ map.get(key));
//        }
        // 使用foreach 进行遍历
        map.forEach((key,value)->{
            System.out.println(key +"="+value);
        });

    }

}
