package com.sf.day24._01_lombda;

import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.function.Supplier;

public class LambdaTest {

    /**
     * 没有jdk 提供函数时间接口我们还需要自己去定义函数式接口,现在在做需求之前
     * 一定是要看jdk 是否有提供如果没有提供或者提供没有办法满足我们的需求在去自己创建
     *
     * 要求使用lambda 表达式去实现
     * 需求1:编写 shop 方法输出消费多少元 monety      有参数无返回值     Consumer 接口
     * 需求2:编写 getCode 方法返回指定位数的5随机验证码  无参数有返回值  Supplier
     * 需求3:编写 getStringRealLength 方法返回字符串真实长度   有参数有返回值 Function
     * 需求4:编写 getString 方法返回长度大于5的字符串的集合     有参数 判断 Predicate     */

    //需求1:编写 shop 方法输出消费多少元 monety      有参数无返回值     Consumer 接口
    @Test
    public void test(){
//        shop(10.00, new Consumer<Double>() {
//            @Override
//            public void accept(Double money) {
//                System.out.println("消费了:"+money);
//            }
//        });
        shop(10.00, e-> System.out.println(e));
    }


    public void shop(double money, Consumer<Double> consumer){
        consumer.accept(money);
    }


//    需求2:编写 getCode 方法返回指定位数的5随机验证码  无参数有返回值  Supplier

    @Test
    public void test2(){
//        String code = getCode(new Supplier<String>() {
//            @Override
//            public String get() {
//                StringBuilder sb = new StringBuilder();
//                for (int i = 0; i < 5; i++) {
//                    sb.append(new Random().nextInt(10));
//                }
//                return sb.toString();
//            }
//        });
//        System.out.println(code);
        //其实在调用PrintStream 当中pringln 方法
        System.out.println();
        String code = getCode(() -> {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < 5; i++) {
                sb.append(new Random().nextInt(10));
            }
            return sb.toString();
        });
        System.out.println(code);
    }

    public String getCode(Supplier<String> supplier){
        return supplier.get();
    }


//    需求3:编写 getStringRealLength 方法返回字符串真实长度   有参数有返回值 Function
    @Test
    public void test3(){
//        Integer length = getStringRealLength("   abcd  ", new Function<String, Integer>() {
//            @Override
//            public Integer apply(String s) {
//                // "   str   "
//                return s.trim().length();
//            }
//        });
//        System.out.println(length);
        System.out.println(getStringRealLength("  abcd  ", e -> e.trim().length()));
    }

    public Integer getStringRealLength(String str, Function<String,Integer> function){
        return function.apply(str);
    }

//    需求4:编写 getString 方法返回长度大于5的字符串的集合     有参数 判断 Predicate
    @Test
    public void test4(){
        List<String> list = Arrays.asList("abcded", "abc", "aaaaaaa", "bb", "cccccccc");
//        List<String> e = getString(list, new Predicate<String>() {
//            @Override
//            public boolean test(String s) {
//                return s.length() > 5;
//            }
//        });
        List<String> newList = getString(list, s -> s.length() > 5);
        System.out.println(newList);
    }

    public List<String> getString(List<String> list, Predicate<String> predicate){
        //1 遍历传入的list集合
        List<String> newList = new ArrayList<>();
        list.forEach(e ->{
            //2 拿到集合当中每一元素
            //3 调用predicate 方法去判断是否符合条件
            //4 如果符合条件放到一个新的集合中
            if(predicate.test(e)){
                //5 返回新的集合
                newList.add(e);
            }
        });
      return newList;
    }
}
