package com.sf.day25._02_anno;

import com.sf.day25._02_anno.anno.ConfigurationProperties;
import com.sf.day25._02_anno.dt.Data;
import org.junit.Test;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class AnnoTest {

    @Test
    public void test() throws IOException {
        // 解析注解的程序
        // 想要做的事情, 是要把db.properties 文件当中属性获取出来, 设置到Data 字段中
        // Properties  反射
        // 1 获取字节码对象
        Class<Data> clz = Data.class;
        // 2 通过字节码对象获取字节码头上注解 clz.getAnnotaion(ConfigurationPropertise.class);
        ConfigurationProperties annotation = clz.getAnnotation(ConfigurationProperties.class);
        // 3 通过注解获取到他value 属性: db.properties
        String value = annotation.value();
        // 4 通过当前线程类加载器获取到 db.properties当中信息放到InputStream  Thread.currentThread();
        InputStream inputStream = Thread.currentThread().getContextClassLoader().getResourceAsStream(value);
        // 5 创建Properties 对象
        Properties properties = new Properties();
        // 6 调用Properties.load 方法进行加载水泥杆
        properties.load(inputStream);
        // 7 调用Data.set方法进行把properties 当中属性设置到对象当中  proeprties.getProperty("useranme");
        Data data = new Data(properties.getProperty("username"),properties.getProperty("password"));
        System.out.println(data);
//        System.out.println(data);
    }

    /**
     * 知识点: 自定义注解 , 反射 , 自定义异常
     * 需求: 现在在Data 当中有一个method1();
     * 要求: 在方法的头上@RequiredLogin(value=true)注解
     * 如果是true 表达需要登录可以访问
     * 如果是false 表示不需要登录就可以访问
     *
     *
     * 要求是在初始化代码块当中去解析注解  method.getAnnotion()
     * 1要先获取字节码 2 获取方法 method1 3 获取注解  4 判断注解的值
     * 最终效果
     *   @Test
     *     public void test2(){
     *         Data data = new Data();
     *         data.method1();
     *     }
     *  如果这个方法贴了这个注解就抛出自定义异常BusinessException("请先登录");
     *  如果没有贴注解就可以正常进行访问
     *
     */
    @Test
    public void test2(){
        Data data = new Data();
        data.method1();
    }
}
