package com.sf.day25._02_anno.anno;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 写元注解: 就是这个注解的限制条件
 * 限制: 在什么时期生效, 限制他能够贴在什么位置
 * 生效时期: Runtime 运行   贴在: 类
 * 在注解中如果你的属性名是value , 并且你只有一个属性, 那属性名可以省略不写
 */
//@Target({ElementType.TYPE,ElementType.METHOD})
@Target(ElementType.TYPE)             // 限制他只能贴在类上
@Retention(RetentionPolicy.RUNTIME)   // 表示在运行时期生效
public @interface ConfigurationProperties {
    // 注解当中定义的方法又叫做属性
    // 现在我们的需求是加载配置文件, 配置文件名字是不固定的,
    // 所以我们应该设计出来一个属性让用户可以修改, 我们也可以给他提供一个默认值叫db.properties
    // 如果用户传递了属性就用用户的属性, 如果用户没有传递属性就用默认属性

    /**
     * 什么时候设计成一个数组,什么时候设计成一个基本类型,String
     * 没有一个固定答案: 要看具体需求业务场景, 比如我们此时配置文件名字就一个单个字符串
     */
    String value() default "db.properties";  // default 就表示他的一个默认值
}
