package com.sf.day25._02_anno.dt;

import com.sf.day25._02_anno.anno.ConfigurationProperties;
import com.sf.day25._02_anno.anno.RequiredLogin;
import com.sf.day25._02_anno.ex.BusinessException;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;

import java.lang.reflect.Method;


@lombok.Data
@AllArgsConstructor
@NoArgsConstructor
// 把自定义注解贴到类上
@ConfigurationProperties
public class Data {
    private String username;
    private String password;

    {
        //解析的业务逻辑
        // 目标: 拿到方法头上的注解的值 进行判断
        // 1 获取字节码信息
        Class<Data> clz = Data.class;
        // 2 根据字节码获取到方法
        try {
            Method method1 = clz.getMethod("method1");
            // 3 根据方法获取方法头注解
            RequiredLogin annotation = method1.getAnnotation(RequiredLogin.class);
            // 4 根据注解获取注解当中值
            boolean value = annotation.value();
            // 5 判断值如果为true 抛出异常
            if(value){
                throw new BusinessException("请登录以后再访问");
            }else{
                System.out.println("无需登录就可以访问");
            }
            // 6 如果为false 不抛出异常
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        }

    }

   @RequiredLogin(value = false)
   public void method1(){
       System.out.println("执行了method1");
   }
}
