package com.sf.day27._01_jdbc_concat;

import com.sf.day27._01_jdbc_concat.domain.Order;

import java.math.BigDecimal;
import java.sql.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class JDBCTest1 {

    public static void main(String[] args) throws Exception {
//        method1();
//        method2();
        method3();
    }

    /**
     * 需求3 完成下单需求
     * 要完成这个需求的前提必须要对表当中每一个什么含义必须要清楚
     * 要求
     *  1 在控制台输入商品id ,数量 ,操作用户id ,
     *  2 如果库存足够可以购买,如果库存不足打印库存不足
     *  3 判断用户余额是否足够 ,如果余额不够打印余额不足
     *  4 如果足够商品减少库存
     *  5 减少用户账户余额
     *  6 在用户订单表添加数据
     */
    private static void method3() throws ClassNotFoundException, SQLException {
//        1 在控制台输入商品id ,数量 ,操作用户id ,
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入商品id:");
        long productId = scanner.nextLong();
        System.out.println("请输入商品数量");
        int count = scanner.nextInt();
        System.out.println("请输入用户id");
        long userId = scanner.nextLong();
//        2 如果库存足够可以购买,如果库存不足打印库存不足
        // 查询product 表
        Class.forName("com.mysql.jdbc.Driver");
        Connection connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
        String sql = "select * from product where id = ?";
        PreparedStatement preparedStatement = connection.prepareStatement(sql);
        preparedStatement.setLong(1,productId);
        // 执行sql 查询结果
        ResultSet resultSet = preparedStatement.executeQuery();
        if(resultSet.next()){
            // 获取库存
            int stock = resultSet.getInt("stock");
            if(stock>=count){
                // 3 判断用户余额是否足够 ,如果余额不够打印余额不足
                // 查询account 表 根据操作id 去操作id 去查询
                String account_sql = "select * from t_account where id = ? and amount >= ?";
                PreparedStatement acountStatement1 =connection.prepareStatement(account_sql);
                acountStatement1.setLong(1,userId);
                acountStatement1.setBigDecimal(2,
                        resultSet.getBigDecimal("price").multiply(new BigDecimal(stock)));
                ResultSet accountResultSet = acountStatement1.executeQuery();
                if(accountResultSet.next()){
                    System.out.println("账户余额充足");
                    // 4 如果足够商品减少库存 product
                    String decrSql = "update product set stock = stock - ? where id = ?";
                    System.out.println(decrSql);
                    PreparedStatement decrPst = connection.prepareStatement(decrSql);
                    // 设置才减少sql 参数
                    decrPst.setInt(1,count);
                    decrPst.setLong(2,productId);
                    decrPst.executeUpdate();
                    //5 减少用户账户余额    商品价格 * 商品数量  1000 * 2 = 2000
                    String decrAmountSQL = "update t_account set amount = amount - ? where id = ?";
                    PreparedStatement decrAmountPst = connection.prepareStatement(decrAmountSQL);
                    BigDecimal price = resultSet.getBigDecimal("price");
                    decrAmountPst.setBigDecimal(1,price.multiply(new BigDecimal(count)));
                    decrAmountPst.setLong(2,userId);
                    decrAmountPst.executeUpdate();
                    //6 在用户订单表添加数据   productName price      userId
                    String productName = resultSet.getString("productName");
                    String insertOrderSQL = "insert into t_order(productName,price,user_id) values(?,?,?)";
                    PreparedStatement insertOrderPst = connection.prepareStatement(insertOrderSQL);
                    insertOrderPst.setString(1,productName);
                    insertOrderPst.setBigDecimal(2,price);
                    insertOrderPst.setLong(3,userId);
                    insertOrderPst.executeUpdate();
                }else{
                    System.out.println("账户余额不足");
                }
            }else{
                System.out.println("库存不足");
            }
        }else{
            System.out.println("数据数据不存在");
        }


        resultSet.close();
        preparedStatement.close();
        connection.close();
    }

    //    要求:  在控制当中输入账号和密码, 如果输入的账号和密码不正确, 要求抛出异常
//    如果登录成功 把这个用户的订单查询出来根据用户id 查询出来这个用户订单
    private static void method2() throws ClassNotFoundException, SQLException {
        //1 创建Scaner 对象
        Scanner scanner = new Scanner(System.in);
        //2 输入用户名和密码
        System.out.println("请输入用户名:");
        String username = scanner.next();
        System.out.println("请输入密码:");
        String password = scanner.next();
        //3 如果用户名和密码为空 抛出异常体用用户账号或者密码不能为空
        if(username == null || password == null){
            throw new RuntimeException("账号或者是密码不能为空");
        }
        //4 根据用户的账号和密码上数据库当中查询数据, 看是否存在数据, 如果不存在提醒用户账号密码错误
        Class.forName("com.mysql.jdbc.Driver");
        Connection connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
        String sql = "select * from user where name=? and password = ?";
        PreparedStatement preparedStatement = connection.prepareStatement(sql);
        preparedStatement.setString(1,username);
        preparedStatement.setString(2,password);

        ResultSet resultSet = preparedStatement.executeQuery();
        if(resultSet.next()){
            System.out.println("登录成功");
            // 查询当前登录用户所拥有订单信息
            // 查询t_order , 根据id 查询
            String sql1 = "select * from t_order where user_id =?";
            PreparedStatement preparedStatement1 = connection.prepareStatement(sql1);
            preparedStatement1.setLong(1,resultSet.getLong("id"));
            ResultSet resultSet1 = preparedStatement1.executeQuery();
            // 最终我们是要一个订单结合 List<Order> list
            List<Order> list =  new ArrayList<>();
            // 如果用户有订单信息 就添加到集合中
            while (resultSet1.next()){
                Order order = new Order();
                order.setId(resultSet1.getLong("id"));
                order.setProductName(resultSet1.getString("productName"));
                order.setUser_id(resultSet1.getLong("user_id"));
                order.setPrice(resultSet1.getBigDecimal("price"));
                list.add(order);
            }
            System.out.println("这是用户的订单信息:"+ list);
        }else{
            System.out.println("登录失败");
        }
    }

    /**
     * 需求: 完成注册
     * 要求: 在控制台输入用户信息保存到数据库中
     * 额外要求  年龄输入只能在1-80 岁, 如果超过就抛出RuntimeExcption
     * 输入邮箱格式 比如要符合邮件格式 , 这里要利用正则表达式字符串有match方法
     * 如果都符合在进行保存
     */
    private static void method1() throws Exception {
        //1 创建Scaner对象
        Scanner scanner = new Scanner(System.in);
        //2 输入用户信息
        System.out.println("请输入用户名:");
        String name = scanner.next();
        System.out.println("请输入邮件:");
        String email = scanner.next();
        System.out.println("请输入年龄:");
        Integer age = scanner.nextInt();
        System.out.println("请输入密码:");
        String password = scanner.next();
        //3 判断年龄是否符合条件
        if(age<1 || age > 80){
            throw new RuntimeException("非法操作");
        }
        //4 判断邮件是否符合条件
        String emailRegex = "^[\\w!#$%&'*+/=?`{|}~^-]+(?:\\.[\\w!#$%&'*+/=?`{|}~^-]+)*@(?:[a-zA-Z0-9-]+\\.)+[a-zA-Z]{2,6}$";
        Pattern pattern = Pattern.compile(emailRegex);

        Matcher matcher = pattern.matcher(email);
        if(!matcher.find()){
            throw new RuntimeException("邮件格式不正确");
        }
        //5 使用JDBC 去把数据保存到数据库中
        //1 加载驱动类
        Class.forName("com.mysql.jdbc.Driver");
        //2 获取连接对象
        Connection connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
        //3 创建语句对象
        String sql = "insert into user(name,age,email,password) values (?,?,?,?)";
        PreparedStatement preparedStatement = connection.prepareStatement(sql);
        preparedStatement.setString(1,name);
        preparedStatement.setInt(2,age);
        preparedStatement.setString(3,email);
        preparedStatement.setString(4,password);

        //4 执行sql 语句
        int count = preparedStatement.executeUpdate();
        // 判断是否插入成功如果插入成功我打印插入成功如果没插入成功抛出RuntimeException
        if(count>0){
            System.out.println("注册成功");
        }else{
            throw new RuntimeException("注册失败");
        }
        //5 释放资源
        connection.close();
        preparedStatement.close();
    }



}
