package com.sf.day27._02_dao;

import com.sf.day27._01_jdbc_concat.domain.Product;
import com.sf.day27._02_dao.dao.AccountDAO;
import com.sf.day27._02_dao.dao.OrderDAO;
import com.sf.day27._02_dao.dao.ProductDAO;
import com.sf.day27._02_dao.dao.impl.AccountDAOImpl;
import com.sf.day27._02_dao.dao.impl.OrderDAOImpl;
import com.sf.day27._02_dao.dao.impl.ProductDAOImpl;
import org.junit.Test;

import java.math.BigDecimal;
import java.util.List;
import java.util.Scanner;

public class DAOTest {

    @Test
    public void test(){
//        调用接口当中方法就可以了, insert jdbc 就写一次
        ProductDAO dao = new ProductDAOImpl();
        dao.insert(new Product(null,"test",10,new BigDecimal(100)));
    }

    @Test
    public void test1(){
        ProductDAO dao = new ProductDAOImpl();
        dao.insert(new Product(null,"test123",20,new BigDecimal(100)));
    }

    /**
     * 需求 : 在控制台当中输入显示第几页 , 每页显示数据  2个值   product
     * 要求展示出来对应的数据 , 以DAO 接口实现
     */
    public static void main(String[] args) {
        method2();
    }

    /**
     * 需求: 支付功能
     * 前提需要先把t_order表添加status 列 默认值是0 , 0 表示未支付 , 1表示已支付
     * 要求: 在控制台当中输入要操作商品,商品数量,操作用户id
     * 1 首先查看账户表金额是否足够      AccountDAO
     * 2 如果商品金额足够, 减少账户余额
     * 3 修改订单状态为已支付状态    OrderDAO
     * 都是以DAO 接口思想操作
     */
    private static void method2() {
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入商品id");
        long productId = scanner.nextLong();
        System.out.println("请输入商品数量");
        int count = scanner.nextInt();
        System.out.println("操作用户id");
        Long userId = scanner.nextLong();
        //1 查询账户余额是否足够  t_account 操作数据库 dao 思想操作
        AccountDAO accountDAO = new AccountDAOImpl();
        ProductDAO productDAO = new ProductDAOImpl();
        OrderDAO orderDAO = new OrderDAOImpl();

        // 由于这边要价格, 获取商品信息才可以得到价格
        Product product = productDAO.get(productId);
        boolean flag = accountDAO.checkAmount(userId, product.getPrice().multiply(new BigDecimal(count)));
//        2 如果商品金额足够, 减少账户余额
        if(flag){
            accountDAO.decrAmount(userId,product.getPrice().multiply(new BigDecimal(count)));
//            3 修改订单状态为已支付状态 由0 变成1    OrderDAO   t_order
            orderDAO.updateOrderStatus(userId);
        }

    }

    private static void method1() {
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入第几页:");
        int currentPage = scanner.nextInt();
        System.out.println("请输入每页实现数据:");
        int pageSize = scanner.nextInt();
        ProductDAO productDAO = new ProductDAOImpl();
        List<Product> list =  productDAO.selectPage(currentPage,pageSize);
        System.out.println(list);

    }




}
