package com.sf.day27._02_dao.dao;

import com.sf.day27._01_jdbc_concat.domain.Product;

import java.util.List;

public interface ProductDAO {
    /**
     * 新增方法
     */
    void insert(Product product);

    /**
     * 编辑操作
     */
    void update(Product product);

    /**
     * 删除操作
     */
    void delete(Long id);

    /**
     * 查询单个商品
     *
     */
    Product get(Long id);

    /**
     * 查询所有的商品
     */
    List<Product> list();

    /**
     * 分页查询
     * currentPage: 当前页
     * pageSize: 每页显示数据
     */
    List<Product> selectPage(int currentPage, int pageSize);


}

