package com.sf.day27._02_dao.dao.impl;

import com.sf.day27._01_jdbc_concat.domain.Product;
import com.sf.day27._02_dao.dao.ProductDAO;

import java.sql.*;
import java.util.ArrayList;
import java.util.List;

public class ProductDAOImpl implements ProductDAO {

    @Override
    public void insert(Product product) {
        Connection connection = null;
        PreparedStatement preparedStatement =null;
        try {
            // 加载驱动
            Class.forName("com.mysql.jdbc.Driver");
            //获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
            //常见预编译语句
            String sql= "insert into product (productName,price,stock) values(?,?,?)";
            preparedStatement = connection.prepareStatement(sql);
            preparedStatement.setString(1,product.getProductName());
            preparedStatement.setBigDecimal(2,product.getPrice());
            preparedStatement.setInt(3,product.getStock());
            preparedStatement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            // 关闭资源
            try {
                if(connection!=null){
                    connection.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void update(Product product) {
        Connection connection = null;
        PreparedStatement preparedStatement =null;
        try {
            // 加载驱动
            Class.forName("com.mysql.jdbc.Driver");
            //获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo", "root", "admin");
            //常见预编译语句
            String sql= "update product set productName=? , price=? , stock=? where id =?";
            preparedStatement = connection.prepareStatement(sql);
            preparedStatement.setString(1,product.getProductName());
            preparedStatement.setBigDecimal(2,product.getPrice());
            preparedStatement.setInt(3,product.getStock());
            preparedStatement.setLong(4,product.getId());
            preparedStatement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            // 关闭资源
            try {
                if(connection!=null){
                    connection.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void delete(Long id) {
        Connection connection = null;
        PreparedStatement preparedStatement =null;
        try {
            // 加载驱动
            Class.forName("com.mysql.jdbc.Driver");
            //获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo", "root", "admin");
            //常见预编译语句
            String sql= "delete from product where id = ?";
            preparedStatement = connection.prepareStatement(sql);
            preparedStatement.setLong(1,id);
            preparedStatement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            // 关闭资源
            try {
                if(connection!=null){
                    connection.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public Product get(Long id) {
        Connection connection = null;
        PreparedStatement preparedStatement =null;
        try {
            // 加载驱动
            Class.forName("com.mysql.jdbc.Driver");
            //获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
            //常见预编译语句
            String sql= "select * from product where id = ?";
            preparedStatement = connection.prepareStatement(sql);
            preparedStatement.setLong(1,id);
            ResultSet resultSet = preparedStatement.executeQuery();
            if(resultSet.next()){
                Product product = new Product();
                product.setPrice(resultSet.getBigDecimal("price"));
                product.setProductName(resultSet.getString("productName"));
                product.setStock(resultSet.getInt("stock"));
                product.setId(resultSet.getLong("id"));
                return product;
            }
            return null;
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            // 关闭资源
            try {
                if(connection!=null){
                    connection.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    @Override
    public List<Product> list() {
        Connection connection = null;
        PreparedStatement preparedStatement =null;
        try {
            // 加载驱动
            Class.forName("com.mysql.jdbc.Driver");
            //获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo", "root", "admin");
            //常见预编译语句
            String sql= "select * from product";
            preparedStatement = connection.prepareStatement(sql);
            ResultSet resultSet = preparedStatement.executeQuery();
            List<Product> list = new ArrayList<>();
            while (resultSet.next()){
                Product product = new Product();
                product.setPrice(resultSet.getBigDecimal("price"));
                product.setProductName(resultSet.getString("productName"));
                product.setStock(resultSet.getInt("stock"));
                product.setId(resultSet.getLong("id"));
                list.add(product);

            }

            return list;
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            // 关闭资源
            try {
                if(connection!=null){
                    connection.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    @Override
    public List<Product> selectPage(int currentPage, int pageSize) {
        // 分页查询关键点就是那个分页的sql  select * from 表 limit 开始索引 , 每页显示数据
        Connection connection =null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
            String sql = "select * from product limit ?,?";
            // 创建语句对象
            PreparedStatement preparedStatement = connection.prepareStatement(sql);
            preparedStatement.setInt(1,(currentPage-1)*pageSize);
            preparedStatement.setInt(2,pageSize);
            //执行sql
            ResultSet resultSet = preparedStatement.executeQuery();
            List<Product> list = new ArrayList<>();
            while (resultSet.next()){
                Product product = new Product();
                product.setPrice(resultSet.getBigDecimal("price"));
                product.setProductName(resultSet.getString("productName"));
                product.setStock(resultSet.getInt("stock"));
                product.setId(resultSet.getLong("id"));
                list.add(product);
            }
            return list;

        } catch (ClassNotFoundException | SQLException e) {
            e.printStackTrace();
        }
        return null;
    }
}
