package com.sf.day28.dao.impl;

import com.sf.day28.dao.ICityDAO;
import com.sf.day28.domain.City;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

public class CityDAOImpl implements ICityDAO {

    @Override
    public List<City> queryByProvince() {
        // 查询所有省 , 省parent_id null 所以我们只需要查询为null 就可以了
        // 加载驱动
        Connection connection =null;
        PreparedStatement preparedStatement =null;
        ResultSet resultSet = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            // 获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
            // 创建语句对象
            String sql = "select * from city where parent_id is null ";
            preparedStatement = connection.prepareStatement(sql);
            // 执行sql语句
            resultSet = preparedStatement.executeQuery();
            List<City> list = new ArrayList<>();
            while (resultSet.next()){
                City city = new City();
                city.setId(resultSet.getLong("id"));
                city.setName(resultSet.getString("name"));
                city.setParentId(resultSet.getLong("parent_id"));
                list.add(city);
            }
            // 关闭资源
            return list;
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try{
                if (connection!=null){
                    connection.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
            try{
                if (preparedStatement!=null){
                    preparedStatement.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }

            try{
                if (resultSet!=null){
                    resultSet.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return null;
    }

    @Override
    public List<City> queryByCity(Long provinceId) {
        // 如何查询省下面市 ,  根据省id 去查询, 查询parent_id =  provinceId
        Connection connection =null;
        PreparedStatement preparedStatement =null;
        ResultSet resultSet = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            // 获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");
            // 创建语句对象
            String sql = "select * from city where parent_id = ? ";
            preparedStatement = connection.prepareStatement(sql);
            preparedStatement.setLong(1,provinceId);
            // 执行sql语句
            resultSet = preparedStatement.executeQuery();
            List<City> list = new ArrayList<>();
            while (resultSet.next()){
                City city = new City();
                city.setId(resultSet.getLong("id"));
                city.setName(resultSet.getString("name"));
                city.setParentId(resultSet.getLong("parent_id"));
                list.add(city);
            }
            // 关闭资源
            return list;
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try{
                if (connection!=null){
                    connection.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
            try{
                if (preparedStatement!=null){
                    preparedStatement.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }

            try{
                if (resultSet!=null){
                    resultSet.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return null;
    }
}
