package com.sf.day28.dao.impl;

import com.sf.day28.dao.IntegralDAO;
import com.sf.day28.util.JDBCUtil;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class IntegralDAOImpl implements IntegralDAO {


    @Override
    public void increIntegral(Long userId, Integer itegral) {
        // 根据userId 查询积分表是否有数据
        Connection connection = JDBCUtil.getConnection();
        PreparedStatement preparedStatement = null;
        ResultSet resultSet = null;
        String selectSQL = "select * from integral where user_id = ?";
        try {
            preparedStatement = connection.prepareStatement(selectSQL);
            preparedStatement.setLong(1,userId);
            resultSet = preparedStatement.executeQuery();
            if(resultSet.next()){
                // 如果有数据, 就update修改
                String updateSQL = "update integral set integral = integral + ? where user_id = ?";
                PreparedStatement updatePST = connection.prepareStatement(updateSQL);
                updatePST.setInt(1,itegral);
                updatePST.setLong(2,userId);
                updatePST.executeUpdate();
            }else{
                // 如果没有数据, 就新增
                String insertSQL = "insert into integral (user_id,integral) values(?,?)";
                PreparedStatement insertPST = connection.prepareStatement(insertSQL);
                insertPST.setLong(1,userId);
                insertPST.setInt(2,itegral);
                insertPST.executeUpdate();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }finally {
           JDBCUtil.close(connection,resultSet,preparedStatement);
        }

    }
}
