package com.sf.day28.util;

import com.alibaba.druid.pool.DruidDataSource;
import com.alibaba.druid.pool.DruidPooledConnection;

import java.io.IOException;
import java.io.InputStream;
import java.sql.SQLException;
import java.util.Properties;

public class DruidUtil {
    private static DruidDataSource druidDataSource = null;
    static {
        // 1 创建出来要给德鲁伊连接池
        druidDataSource = new DruidDataSource();
        // 因为连接池中药创建连接对象, 创建连接对象, 连接对象需要设置连接四要素
        // 配置写死, 要加载配置文件当中信息
        InputStream resourceAsStream = Thread.currentThread().getContextClassLoader().getResourceAsStream("db.properties");
        Properties properties = new Properties();
        try {
            properties.load(resourceAsStream);
        } catch (IOException e) {
            e.printStackTrace();
        }
        druidDataSource.setDriverClassName(properties.getProperty("driverClassName"));
        druidDataSource.setUsername(properties.getProperty("username"));
        druidDataSource.setPassword(properties.getProperty("password"));
        druidDataSource.setUrl(properties.getProperty("url"));

        druidDataSource.setInitialSize(5);  //初始化创建连接的个数
    }

    public static DruidPooledConnection getConection(){


        // 如何上连接池中获取连接对象
        DruidPooledConnection connection = null;
        try {
            connection = druidDataSource.getConnection();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return connection;
    }
}
