package com.sf.day29.dao;

import com.sf.day29.domain.Employee;

import java.util.List;

public interface IEmployeeDAO {
    /**
     * 新增
     */
    void insert(Employee employee);

    /**
     * 删除
     */
    void delete(Long id);

    /**
     * 修改
     */
    void update(Employee employee);

    /**
     * 查询单个
     */
    Employee get(Long id);

    /**
     * 查询所有
     */
    List<Employee> list();

    /**
     * 根据id 查询用户信息, 并且要查询出来这个用户所在的部门
     */
    Employee selectEmployeeInfo(Long id);

    /**
     * 登录查询
     * @param username
     * @param password
     * @return
     */
    Employee login(String username, String password);

}
