package com.sf.day29.dao.impl;

import com.alibaba.druid.pool.DruidPooledConnection;
import com.sf.day28.util.DruidUtil;
import com.sf.day28.util.JDBCUtil;
import com.sf.day29.dao.ICarShopDAO;
import com.sf.day29.domain.CarShop;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class CarShopDAOImpl implements ICarShopDAO {
    @Override
    public List<CarShop> selectCarShopsByEmpId(Long id) {
        // 获取连接对象
        DruidPooledConnection conection = DruidUtil.getConection();
        PreparedStatement preparedStatement = null;
        ResultSet resultSet = null;
        // 创建SQL 语句
        String sql = "select * from carShop where userId = ?";
        try {
            preparedStatement = conection.prepareStatement(sql);
            preparedStatement.setLong(1,id);
             resultSet = preparedStatement.executeQuery();
            List<CarShop> list = new ArrayList<>();
            while (resultSet.next()){
                CarShop carShop = new CarShop();
                carShop.setId(resultSet.getLong("id"));
                carShop.setUserId(resultSet.getLong("userId"));
                carShop.setProductName(resultSet.getString("productName"));
                carShop.setPrice(resultSet.getBigDecimal("price"));
                carShop.setStock(resultSet.getInt("stock"));
                list.add(carShop);
            }
            return list;
        } catch (SQLException e) {
            e.printStackTrace();
        }finally {
            JDBCUtil.close(conection,resultSet,preparedStatement);
        }
        return null;

    }
}
